=== debian/changelog ===
g2o (0~20230806-5) unstable; urgency=medium

  * Build is reproducible. Thanks to Chris Lamb (Closes: #1114950)

 -- Dima Kogan <dkogan@debian.org>  Mon, 10 Nov 2025 21:18:45 -0800

g2o (0~20230806-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061964

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 09:35:01 +0000

g2o (0~20230806-4) unstable; urgency=medium

  * Team upload
  * Source-only upload to allow migration to happen
  * Raising Standards version to 4.6.2:
    - Rules-Requires-Root: no

 -- Pierre Gruet <pgt@debian.org>  Thu, 02 Nov 2023 08:00:14 +0100

g2o (0~20230806-3) unstable; urgency=medium

  * Fixed arch=all build (Closes: #1054252)
  * Ifxed arch-i386 build

 -- Dima Kogan <dkogan@debian.org>  Sun, 29 Oct 2023 17:56:35 -0700

g2o (0~20230806-2) unstable; urgency=medium

  * Fixed build on armhf

 -- Dima Kogan <dkogan@debian.org>  Tue, 03 Oct 2023 23:50:24 -0700

g2o (0~20230806-1) unstable; urgency=medium

  * Initial release (Closes: #1031099)

 -- Dima Kogan <dkogan@debian.org>  Sun, 06 Aug 2023 13:04:40 -0700
