=== debian/control ===
Source: g2o
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 11),
               cmake,
               libopenblas-dev,
               libsuitesparse-dev,
               libopengl-dev,
               libqglviewer-headers,
               libeigen3-dev,
               libglut-dev,
               libtbb-dev,
               libmetis-dev,
               libceres-dev,
               libgmock-dev
Build-Depends-Indep: 
               doxygen,
               graphviz,
               fig2dev,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-science,
               ghostscript
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.6.2
Homepage: http://www.g2o.org
Vcs-Git: https://salsa.debian.org/science-team/g2o.git
Vcs-Browser: https://salsa.debian.org/science-team/g2o
Rules-Requires-Root: no

Package: libg2o0t64
Provides: ${t64:Provides}
Replaces: libg2o0
Breaks: libg2o0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ framework for optimizing graph-based nonlinear error functions
 A wide range of problems in robotics as well as in computer-vision involve the
 minimization of a non-linear error function that can be represented as a graph.
 Typical instances are simultaneous localization and mapping (SLAM) or bundle
 adjustment (BA). The overall goal in these problems is to find the
 configuration of parameters or state variables that maximally explain a set of
 measurements affected by Gaussian noise. g2o is an open-source C++ framework
 for such nonlinear least squares problems. g2o has been designed to be easily
 extensible to a wide range of problems and a new problem typically can be
 specified in a few lines of code. The current implementation provides solutions
 to several variants of SLAM and BA. g2o offers a performance comparable to
 implementations of state-of-the-art approaches for the specific problems
 (02/2011)

Package: libg2o-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libg2o0t64 (= ${binary:Version}),
         libceres-dev, libeigen3-dev
Recommends: libg2o-doc
Description: C++ framework for optimizing graph-based nonlinear error functions
 A wide range of problems in robotics as well as in computer-vision involve the
 minimization of a non-linear error function that can be represented as a graph.
 Typical instances are simultaneous localization and mapping (SLAM) or bundle
 adjustment (BA). The overall goal in these problems is to find the
 configuration of parameters or state variables that maximally explain a set of
 measurements affected by Gaussian noise. g2o is an open-source C++ framework
 for such nonlinear least squares problems. g2o has been designed to be easily
 extensible to a wide range of problems and a new problem typically can be
 specified in a few lines of code. The current implementation provides solutions
 to several variants of SLAM and BA. g2o offers a performance comparable to
 implementations of state-of-the-art approaches for the specific problems
 (02/2011)
 .
 Development files

Package: libg2o-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: C++ framework for optimizing graph-based nonlinear error functions
 A wide range of problems in robotics as well as in computer-vision involve the
 minimization of a non-linear error function that can be represented as a graph.
 Typical instances are simultaneous localization and mapping (SLAM) or bundle
 adjustment (BA). The overall goal in these problems is to find the
 configuration of parameters or state variables that maximally explain a set of
 measurements affected by Gaussian noise. g2o is an open-source C++ framework
 for such nonlinear least squares problems. g2o has been designed to be easily
 extensible to a wide range of problems and a new problem typically can be
 specified in a few lines of code. The current implementation provides solutions
 to several variants of SLAM and BA. g2o offers a performance comparable to
 implementations of state-of-the-art approaches for the specific problems
 (02/2011)
 .
 Documentation
