=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS   := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

export FORCE_SOURCE_DATE = 1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure --				\
		-DCMAKE_BUILD_TYPE=RelWithDebInfo	\
		-DBUILD_SHARED_LIBS=ON			\
		-DG2O_USE_CHOLMOD=ON			\
		-DG2O_USE_LGPL_LIBS=ON			\
		-DG2O_USE_CSPARSE=ON			\
		-DG2O_USE_OPENMP=OFF			\
		-DG2O_USE_OPENGL=ON			\
		-DG2O_USE_VENDORED_CERES=OFF		\
		-DG2O_BUILD_SLAM2D_TYPES=ON		\
		-DG2O_BUILD_SLAM2D_ADDON_TYPES=ON	\
		-DG2O_BUILD_DATA_TYPES=ON		\
		-DG2O_BUILD_SCLAM2D_TYPES=ON		\
		-DG2O_BUILD_SLAM3D_TYPES=ON		\
		-DG2O_BUILD_SLAM3D_ADDON_TYPES=ON	\
		-DG2O_BUILD_SBA_TYPES=ON		\
		-DG2O_BUILD_ICP_TYPES=ON		\
		-DG2O_BUILD_SIM3_TYPES=ON		\
		-DG2O_BUILD_APPS=ON			\
		-DG2O_BUILD_EXAMPLES=OFF		\
		-DG2O_FAST_MATH=OFF			\
		-DDO_SSE_AUTODETECT=OFF			\
		-DBUILD_CODE_COVERAGE=OFF		\
		-DBUILD_WITH_MARCH_NATIVE=OFF		\
		-DBUILD_UNITTESTS=ON			\
		-DG2O_BUILD_BENCHMARKS=OFF

override_dh_auto_configure-indep:
	true


ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))

override_dh_auto_build-indep:
	$(MAKE) -C doc g2o.pdf
	cd doc/doxygen && doxygen doxy.config

else

override_dh_auto_build-indep:
	true

endif

override_dh_auto_build-arch:
	dh_auto_build


override_dh_auto_test-indep:
	true

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
else
	true
endif

# remove files I shouldn't ship
override_dh_auto_install-arch:
	dh_auto_install
	rm debian/tmp/usr/include/g2o/autodiff/LICENSE
	sed -i -e 's@^\(#define G2O_SRC_DIR\).*@\1 "/nonexistent"@' debian/tmp/usr/include/g2o/config.h

override_dh_auto_install-indep:
	true
